﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Constructors
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Create an object with a cunstructor
            RealEstate rl = new RealEstate("Some street", 7, "House");
            MessageBox.Show("Address: " + rl.street + ", real estate type: " + rl.type);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //Generate triangles
            Triangle t = new Triangle();
            MessageBox.Show("Triangle lines: " + t.a.ToString() + ", " + t.b.ToString() + ", " + t.c.ToString());
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //Track wallet
            Wallet w = new Wallet("James", 860);
            w.deposit(220.22);
            w.withdraw(86.43);
            MessageBox.Show("Money: " + w.money.ToString());
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //Calculate population density
            Country c = new Country();
            c.name = "Crypton";
            c.surface = 500000;
            c.population = 2000000000;
            MessageBox.Show("Population density of " + c.name.ToString() + " is " + c.Density().ToString() + " inhabitants per km2");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //Keep track of sales
            Seller s = new Seller();
            for (int i = 1; i <= 12; i++)
            {
                s.sales[i - 1] = Convert.ToDouble(Microsoft.VisualBasic.Interaction.InputBox("Sales for month #" + i));
            }

        }
    }

    class RealEstate
    {
        public string street;
        public int number;
        public string type;

        //constructor
        public RealEstate(string s, int n, string t)
        {
            this.street = s;
            this.number = n;
            this.type = t;
        }
    }

    class Triangle
    {
        public int a, b, c;
        public Triangle()
        {
            Random rnd = new Random();
            this.a = rnd.Next(1, 10);
            this.b = rnd.Next(1, 10);
            while (true)
            {
                this.c = rnd.Next(1, 10);
                if ((a + b) > c && (a + c) > b && (b + c) > a)
                {
                    break;
                }
            }
        }
    }

    public class Wallet
    {
        public string name;
        public double money;

        public Wallet(string name, double amount)
        {
            this.name = name;
            money = amount;
        }

        public void deposit(double amount)
        {
            money += amount;
        }

        public void withdraw(double amount)
        {
            money -= amount;
        }
    }

    class Country
    {
        public string name;
        public int surface;
        public int population;
        public double Density()
        {
            return population / surface;
        }
    }

    class Seller
    {
        public double[] sales;
        public Seller()
        {
            sales = new double[12];
        }
        public double YearlySales()
        {
            double sum = 0.0;
            for (int i = 0; i < 12; i++)
            {
                sum += sales[i];
            }
            return sum;
        }
    }
}
